import sublime, sublime_plugin
import os

class ImpactEntityCommand(sublime_plugin.TextCommand):
  def run(self, edit):
    cur_view = sublime.active_window().active_view()
    cur_path = cur_view.file_name()
    cur_folder = os.path.dirname(cur_path)

    name = os.path.basename(cur_path).replace('.js', '')

    path_split = cur_folder.split('/')
    path_split.reverse()
    path_list = []

    for f in path_split:
      if f == "lib":
        break
      else:
        path_list.append( f )

    path_list.reverse()

    module_name = '.'.join(path_list) + '.' + name

    s = """ig.module(
  '%s'
)
${1:.requires(
  '${2:impact.entity}'${3:,
  '$4'}
)}
.defines(function() {'use strict';

  ig.global.Entity%s = ig.Entity.extend({
    size: {x: ${10:16}, y: ${11:16}},${12:
    offset: {x: ${13:8}, y: ${14:8}\},}

    animSheet: new ig.AnimationSheet( 'media/$15', ${16:${10}}, ${17:${11}} ),

    init: function( x, y, s ) {
      this.parent( x, y, s )

      $20
    }

  })

})
""" % (module_name, name)

    replacement = {'contents': s}
    self.view.run_command('insert_snippet', replacement)
